/*
* Title: WebHamsters
* Description: Javascript library to add multi-threading support to javascript by exploiting concurrent web workers
* Author: Austin K. Smith 
* Contact: austin@asmithdev.com
* Copyright: 2015 Austin K. Smith - austin@asmithdev.com
* License: Artistic License 2.0
*/
var hamsters={version:"2.9",debug:!1,cache:!1,maxThreads:Math.ceil(1.25*(navigator.hardwareConcurrency||1)),tools:{},wheel:{legacy:!1,queue:{running:[],pending:[]},tasks:[],errors:[],setup:{},uri:null}};self.wakeUp=function(){"use strict";self.isIE=function(e){return new RegExp("msie"+(isNaN(e)?"":"\\s"+e),"i").test(navigator.userAgent)},self.isLegacy=function(e){try{(!window.Worker||-1!==navigator.userAgent.indexOf("Kindle/3.0")||-1!==navigator.userAgent.indexOf("Mobile/8F190")||-1!==navigator.userAgent.indexOf("IEMobile")||self.isIE(10))&&(hamsters.wheel.legacy=!0)}catch(r){hamsters.wheel.legacy=!0}e(hamsters.wheel.legacy)},hamsters.checkErrors=function(){var e=hamsters.wheel.errors||[];return{msg:"There are currently "+e.length+" errors captured in the wheel",total:e.length,errors:e}},hamsters.tools.splitArray=function(e,r){e.length&&!e.slice&&(e=hamsters.wheel.normalizeArray(e));var t=[],a=0;if(e){for(var s=e.length,n=Math.ceil(s/r);s>a;)t.push(e.slice(a,a+=n));return t}return[]},hamsters.tools.randomArray=function(e,r){if(!e||!r)return void hamsters.wheel.errors.push({msg:"Unable to generate random array, missing required params"});var t={count:e};hamsters.run(t,function(){for(var e=t.count,r=0;e>r;)rtn.data[rtn.data.length]=Math.round(99*Math.random()+1),r+=1},function(e){r(e)},1,!1,"Int32",!1)},hamsters.wheel.checkCache=function(e,r){var t,a=0,s=sessionStorage.length;for(a;s>a;a+=1)if(t=JSON.parse(sessionStorage[a]),t&&t["#"]===e&&t.dT===r){var n=t.oP;return r&&!hamsters.wheel.legacy&&(n=hamsters.wheel.processDataType(r,t.oP)),n}},hamsters.wheel.memoize=function(e,r,t,a){var s=hamsters.wheel.hashResult({func:e,dT:a,input:r});if(!hamsters.wheel.checkCache(s,a))try{sessionStorage.setItem(sessionStorage.length,JSON.stringify({"#":s,dT:a,oP:t}))}catch(n){if("QuotaExceededError"===n.name){sessionStorage.clear();try{sessionStorage.setItem(sessionStorage.length,JSON.stringify({"#":s,dT:a,oP:t}))}catch(o){return}}}},hamsters.wheel.compareArrays=function(e,r){return e.length!==r.length?!1:e.every(function(e,t){return e===r[t]})},self.populateElements=function(){hamsters.wheel.setup.getOrCreateElement(0)},hamsters.wheel.setup.getOrCreateElement=function(e){var r=document.getElementById("hamster"+e)||null;if(!r){var t=hamsters.wheel.giveHamsterWork();return r=document.createElement("script"),r.type="javascript/worker",r.id="hamster"+e,r.text="("+String(t)+"());",document.getElementsByTagName("head")[0].appendChild(r),r}return r},hamsters.wheel.giveHamsterWork=function(){var work=function(){var params,output,respond=function(e,r){"na"!==params.dataType?(output=processDataType(params.dataType,e.data),e.data=output.buffer,e.dataType=params.dataType,self.postMessage({results:e||null,msg:r||""},[output.buffer])):self.postMessage({results:e||null,msg:r||""})},processDataType=function(e,r){return"uint32"===e?new Uint32Array(r):"uint16"===e?new Uint16Array(r):"uint8"===e?new Uint8Array(r):"uint8clamped"===e?new Uint8ClampedArray(r):"int32"===e?new Int32Array(r):"int16"===e?new Int16Array(r):"int8"===e?new Int8Array(r):"float32"===e?new Float32Array(r):"float64"===e?new Float64Array(r):r};self.onmessage=function(e){var rtn={success:!0,data:[]};params=e.data,"string"==typeof params&&(params=JSON.parse(e.data)),"na"!==params.dataType&&"object"==typeof params.array&&(params.array=processDataType(params.dataType,params.array));var fn=eval("("+params.fn+")");fn?(fn(),respond(rtn)):(rtn.success=!1,rtn.error="Missing function",rtn.msg="Error encounted check errors for details",respond(rtn))}};return work},hamsters.wheel.sort=function(e,r){return"desc"===r?Array.prototype.sort.call(e,function(e,r){return r-e}):"asc"===r?Array.prototype.sort.call(e,function(e,r){return e-r}):"ascAlpha"===r?e.sort():"descAlpha"===r?e.reverse():void 0},hamsters.run=function(e,r,t,a,s,n,o,h){if(!e||!r)return"Error processing for loop, missing params or function";var l=hamsters.wheel.tasks.length;a=a||hamsters.maxThreads,hamsters.wheel.newTask(l,a,h,n,r,t);var i=hamsters.wheel.tasks[l];t=t||null;var u={array:[]};if(u.fn=r.toString(),n=n?n.toLowerCase():"na",hamsters.cache&&e.array&&0!==e.array.length){o=o||!0;var m=hamsters.wheel.hashResult({func:r,dT:"na",input:e.array}),c=hamsters.wheel.checkCache(m,n);if(c&&t)return void setTimeout(function(){t(c),hamsters.wheel.tasks[l]=null},4)}var p;for(p in e)e.hasOwnProperty(p)&&"array"!==p&&(u[p]=e[p]);u.dataType=n||null;var d=e.array||null;e.array&&1!==i.threads&&(d=hamsters.tools.splitArray(e.array,i.threads));for(var w=0;w<i.threads;)d&&1!==i.threads?hamsters.wheel.newWheel(d[w],u,s,t,l,w,null,o):hamsters.wheel.newWheel(d,u,s,t,l,w,null,o),w+=1},hamsters.wheel.newTask=function(e,r,t,a,s,n){hamsters.wheel.tasks.push({id:e,workers:[],count:0,threads:r,input:[],dataType:a||null,fn:s||null,output:[],order:t||null,callback:n})},hamsters.wheel.trackInput=function(e,r,t,a,s){e.input.push({input:r,workerid:t,taskid:a,params:s,start:(new Date).getTime()})},hamsters.wheel.poolThread=function(e,r,t,a,s,n,o,h){e.pending.push({memoize:h,input:r,params:t,workerid:a,callback:s,taskid:n,aggregate:o})},hamsters.wheel.trackThread=function(e,r,t){e.workers[e.workers.length]=t,r.running[r.running.length]=t},hamsters.wheel.legacyProcessor=function(food,inputArray,callback){setTimeout(function(){var params=food,rtn={success:!0,data:[]},respond=function(e){callback(e)};params.array=inputArray;var fn=eval("("+params.fn+")");fn?(fn(),respond(rtn)):(rtn.success=!1,rtn.error="Missing function",rtn.msg="Error encounted check errors for details",respond(rtn))},4)},hamsters.wheel.createHamster=function(){if(!hamsters.wheel.uri){var e=hamsters.wheel.setup.getOrCreateElement(0),r=hamsters.wheel.createBlob(e.textContent);hamsters.wheel.uri=window.URL.createObjectURL(r),setTimeout(function(){hamsters.wheel.terminateHamster(r)},4)}var t=new Worker(hamsters.wheel.uri);return t},hamsters.wheel.createBlob=function(e){if(Blob)return new Blob([e],{type:"application/javascript"});var r=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder;if(r){var t=new r;return t.append([e],{type:"application/javascript"}),t=t.getBlob()}},hamsters.tools.aggregate=function(e,r){return e?e.length>20?e:r?hamsters.wheel.aggregateTypedArrays(e,r):e.reduce(function(e,r){return e.concat(r)}):void console.error("Missing array")},hamsters.wheel.getOutput=function(e,r,t){return r?hamsters.tools.aggregate(e,t):e},hamsters.wheel.processQueue=function(e){var r=hamsters.wheel.queue.pending.shift();r&&hamsters.wheel.newWheel(r.input,r.params,r.aggregate,r.callback,r.taskid,r.workerid,e,r.memoize)},hamsters.wheel.terminateHamster=function(e){return e?e.close?void e.close():e.msClose?void e.msClose():void(e.slice&&(e=e.slice(0,0))):void 0},hamsters.wheel.trainHamster=function(e,r,t,a,s,n,o){n.onmessage=function(h){var l=hamsters.wheel.queue;0===l.pending.length&&setTimeout(function(){n.terminate()},4),l.running.splice(l.running.indexOf(e),1);var i=hamsters.wheel.tasks[a];if(!i)return hamsters.wheel.errors=hamsters.wheel.errors.concat({timeStamp:h.timeStamp,msg:"Error, unable to match thread to task, throwing exception",taskid:a,workerid:s,aggregate:r,callback:t}),void console.error("Fatal Exception, unable to match thread #"+s+" to task #"+a+", cannot continue. Check errors for more details");i.workers.splice(i.workers.indexOf(s),1);var u=h.data.results;if(u.dataType&&"object"==typeof u.data&&(u.data=hamsters.wheel.processDataType(u.dataType,u.data)),i.output[s]=u.data,0===i.workers.length&&i.count===i.threads){var m=hamsters.wheel.getOutput(i.output,r,u.dataType);if(hamsters.debug&&console.info("Execution Complete! Elapsed: "+(h.timeStamp-i.input[0].start)/1e3+"s"),t(i.order?hamsters.wheel.sort(m,i.order):m),hamsters.wheel.tasks[a]=null,hamsters.cache&&o!==!1){var c=i.input[0].input;m.length>0&&!u.dataType?setTimeout(function(){hamsters.wheel.memoize(i.fn,c,m,"na")},4):m.length>0&&u.dataType&&setTimeout(function(){hamsters.wheel.memoize(i.fn,c,hamsters.wheel.normalizeArray(m),u.dataType)},4)}}else"verbose"===hamsters.debug&&console.info("Hamster #"+e+" finished @ "+h.timeStamp);0!==l.pending.length&&hamsters.wheel.processQueue(n)},n.onerror=function(r){n.terminate();var t="Error Hamster #"+e+": Line "+r.lineno+" in "+r.filename+": "+r.message;hamsters.wheel.errors=hamsters.wheel.errors.concat({msg:t}),console.error(t)}},hamsters.wheel.normalizeArray=function(e){var r=[],t=0,a=e.length;for(t;a>t;t++)r.push(e[t]);return r},hamsters.wheel.aggregateTypedArrays=function(e,r){var t,a=0,s=e.length,n=0;for(a;s>a;a+=1)n+=e[a].length;t=hamsters.wheel.processDataType(r,n);var o=0,h=0;for(o;s>o;o+=1)t.set(e[o],h),h+=e[o].length;return t},hamsters.wheel.processDataType=function(e,r){return"uint32"===e?new Uint32Array(r):"uint16"===e?new Uint16Array(r):"uint8"===e?new Uint8Array(r):"uint8clamped"===e?new Uint8ClampedArray(r):"int32"===e?new Int32Array(r):"int16"===e?new Int16Array(r):"int8"===e?new Int8Array(r):"float32"===e?new Float32Array(r):"float64"===e?new Float64Array(r):r},hamsters.wheel.generateHash=function(e){e=String(e);var r,t=0;for(r=e.length-1;r>=0;r--)t+=(t<<5)-t+e.charCodeAt(r)&4294967295;return t},hamsters.wheel.hashResult=function(e){var r=0;for(var t in e)e.hasOwnProperty(t)&&(r+=hamsters.wheel.generateHash("object"==typeof e[t]&&e[t].length&&!e[t].slice?t+String(hamsters.wheel.normalizeArray(e[t])):t+e[t]));return r},hamsters.wheel.feedHamster=function(e,r,t){if(t&&r.dataType?r.array=hamsters.wheel.processDataType(r.dataType,t):t&&(r.array=t),r.array&&r.array.buffer){var a=r.array.buffer;r.array=a,e.postMessage(r,[a])}else e.postMessage(r)},self.isLegacy(function(e){e?hamsters.wheel.newWheel=function(e,r,t,a,s,n,o,h){var l=hamsters.wheel.tasks[s];if(!l)return hamsters.wheel.errors.push({msg:"Error, unable to match thread to task, throwing exception",params:r,aggregate:t,callback:a}),void console.error("Error, unable to match thread to task "+s+", throwing exception. Check errors for more details");var i=hamsters.debug;hamsters.wheel.legacyProcessor(r,e,function(e){if(l.count++,l.output[n]=e.data,l.count===l.threads){var r=hamsters.wheel.getOutput(l.output,t,e.dataType);i&&console.info("Execution Complete! Elapsed: "+((new Date).getTime()-l.input[0].start)/1e3+"s"),a(r),hamsters.wheel.tasks[s]=null,hamsters.cache&&h!==!1&&(e.data.length>0&&!e.dataType?setTimeout(function(){hamsters.wheel.memoize(l.fn,l.input,e.data,"na")},4):e.data.length>0&&e.dataType&&setTimeout(function(){hamsters.wheel.memoize(l.fn,l.input,hamsters.wheel.normalizeArray(e.data),e.dataType)},4))}})}:(hamsters.wheel.newWheel=function(e,r,t,a,s,n,o,h){var l=hamsters.wheel.tasks[s];if(!l)return hamsters.wheel.errors.push({msg:"Error, unable to match thread to task, throwing exception",params:r,aggregate:t,callback:a}),void console.error("Error, unable to match thread to task "+s+", throwing exception. Check errors for more details");var i=hamsters.wheel.queue;if(hamsters.maxThreads&&hamsters.maxThreads<=i.running.length)return void hamsters.wheel.poolThread(i,e,r,n,a,s,t,h);var u=n||l.count,m=hamsters.debug;(m||h)&&(hamsters.wheel.trackInput(l,e,u,s,r),"verbose"===m&&console.info("Spawning Hamster #"+u+" @ "+(new Date).getTime())),hamsters.wheel.trackThread(l,i,u),o||(o=hamsters.wheel.createHamster()),hamsters.wheel.trainHamster(u,t,a,s,u,o,h),hamsters.wheel.feedHamster(o,r,e),l.count++},self.populateElements())})},self.wakeUp();